OPTION BINARY BASE 1       ' Start counting bytes at 1, not 0
Parameter$ = COMMAND$      ' fetch parameter
Parameter$ = RTRIM$(UCASE$(Parameter$))               ' force upper case; trim spaces
Parameter$ = LTRIM$(Parameter$, "CHECKSUM ")          ' strip invoked program
Parameter$ = LTRIM$(Parameter$)                       ' strip leading spaces
FileName1$ = EXTRACT$(Parameter$, " ")                ' parse source file's name
Parameter$ = LTRIM$(Parameter$, FileName1$)           ' strip file name
FileName2$ = LTRIM$(Parameter$)                       ' strip leading spaces
Total?? = 0                ' initialize the checksum 'register'
ByteCounter& = 0           ' initialize a counter

IF LEN(FileName2$) = 0 THEN
  PRINT "Scanning file: "; FileName1$
  PRINT "Scanning.";
  BFN% = FREEFILE
  OPEN FileName1$ FOR BINARY ACCESS READ LOCK WRITE AS #BFN%
  WHILE NOT EOF(BFN%)
    INCR ByteCounter&
    GET #BFN%, ByteCounter&, Temp?
    IF ByteCounter& MOD 1000 = 0 THEN PRINT ".";
    Total?? = (Total?? + Temp?) MOD 65536
  WEND
  PRINT "Done!"
  LowPart% = Total?? MOD 256
  HighPart% = Total?? \ 256
  LowPart$ = RIGHT$("0" + HEX$(LowPart%), 2)
  HighPart$ = RIGHT$("0" + HEX$(HighPart%), 2)
  Total$ = HighPart$ + " " + LowPart$
  PRINT "Bytes scanned: "; ByteCounter&
  PRINT "File's checksum: "; Total$
  PRINT
ELSE
  SFN% = FREEFILE
  OPEN FileName2$ FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #SFN%
  PRINT #SFN%, "Scanning file: "; FileName1$
  PRINT "Scanning.";
  BFN% = FREEFILE
  OPEN FileName1$ FOR BINARY ACCESS READ LOCK WRITE AS #BFN%
  WHILE NOT EOF(BFN%)
    INCR ByteCounter&
    GET #BFN%, ByteCounter&, Temp?
    IF ByteCounter& MOD 1000 = 0 THEN PRINT ".";
    Total?? = (Total?? + Temp?) MOD 65536
  WEND
  PRINT "Done!"
  LowPart% = Total?? MOD 256
  HighPart% = Total?? \ 256
  LowPart$ = RIGHT$("0" + HEX$(LowPart%), 2)
  HighPart$ = RIGHT$("0" + HEX$(HighPart%), 2)
  Total$ = HighPart$ + " " + LowPart$
  PRINT #SFN%, "Bytes scanned: ";ByteCounter&
  PRINT #SFN%, "File's checksum: ";Total$
  PRINT #SFN%, ""
END IF
CLOSE
END
